leetcode(easy)_1

leetcode1

  • 题目描述
  • 解答
    • 1.暴力
    • 2.哈希表
    • 3.排序

题目描述

求数组内哪两个位置的数加起来等于给定和。

解答

1.暴力

双重循环遍历整个数组

2.哈希表

用哈希表将原来数组保存,然后再遍历数组,查找target-当前数的值是否在哈希表中。

class Solution {
public:
    vector twoSum(vector& nums, int target) {
        map hash;
        vector a;
        for (int i = 0; i < nums.size(); i++){
            hash[nums[i]] = i;
        }
        for (int i = 0;i < nums.size(); i++){
            if(hash.find(target - nums[i]) != hash.end())
            {
                if(i == hash[target-nums[i]])
                    continue;
                a.push_back(i);
                a.push_back(hash[target - nums[i]]);
                break;
            }        
        }
        return a;
    }
};

3.排序

先将数组从小到大排序,然后设置头尾两个指针,进行遍历。为了保留原始数组中数的下标,将之前的数组用结构体进行保存。

#include
#include
using namespace std;
struct p{
    int value;
    int index;
};
bool cmp(const p &a, const p &b){
    return a.value < b.value;
}
class Solution {
public:
    vector twoSum(vector& nums, int target) {
        vector a;
        vector

tmp; for(int i = 0; i < nums.size(); i++){ p t; t.value = nums[i]; t.index = i; tmp.push_back(t); } sort(tmp.begin(), tmp.end(), cmp); int l = 0, r = tmp.size() - 1; while(l < r) { if(tmp[l].x + tmp[r].x == target){ a.push_back(tmp[l].index); a.push_back(tmp[r].index); break; } else if(tmp[l].value + tmp[r].value < target){ l++; } else if(tmp[l].value + tmp[r].value > target){ r--; } } return a; } };

你可能感兴趣的:(leetcode,水)